#region                                                                ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_usex64=n
#endregion                                                                ;**** Directives created by AutoIt3Wrapper_GUI ****
#region                                                                ;**** Directives created by AutoIt3Wrapper_GUI ****
#endregion                                                                ;**** Directives created by AutoIt3Wrapper_GUI ****
#include "..\Includes\opengl.au3"
#include <opencl_easy.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <GDIConstants.au3>
#include <Misc.au3>
#include <CLGL_easy.au3>


;INFOS!!!
;erst textur in openGL erstellen und binden, dann erst CL-context erstellen


;programmspezifisch...
$CL_DEBUGFLAG = 1                       ;1 debug aus
Global $width = 256 * 3                 ;breite und hhe des Fensters
Global $height = 256 * 3
Local $iAlpha = 0.00                    ; Rotationswinkel um den Wrfel zu drehen.

Global $textur_width = $width, $textur_height = $height ;texturmae = Fenstermae

Local $step = 1.02                      ;das ist die Schrittweite, um die der Tunnelflug ein Frame weiter gezeichnet wird
Local $steps = 0                        ;Beginn des Fluges...

$KernelSource = FileRead("Tunnelflug.cl") ;kernelsource aus datei laden
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $KernelSource = ' & $KernelSource & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console



;OpenGL und extensions initialisieren
glInit()
;gluInit()
glfwInit()

;Fenster einrichten
glfwOpenWindowHint($GLFW_WINDOW_NO_RESIZE, 1) ; Resize nicht mglich
glfwOpenWindow($width, $height, 8, 8, 8, 0, 8, 0, $GLFW_WINDOW) ; Fenster ffnen
glfwSetWindowTitle("tunnelflug ")       ; Titel setzen

glMatrixMode($GL_PROJECTION)            ; Projektionseinstellungen
;gluPerspective(14, $width / $height, 5, 40)                        ; Perspektive
glOrtho(0, $width, 0, $height, 0, 128)
glViewport(0, 0, $width, $height)       ; Viewport
glMatrixMode($GL_MODELVIEW)             ; Betrachtungsmodus


;GLCL context erstellen und an hdc (window) binden
setGLCLcontext()                        ;aktuellen gl-context an dc (window) binden

;leere textur erstellen mit hhe und breite
Local $textur1 = createGLCLtexturebuffer($textur_width, $textur_height)

;textur bereitstellen
glEnable($GL_TEXTURE_2D)                ; aktuelle Textur einschalten
;glEnable($GL_DEPTH_TEST)                                             ;tiefentest bei 3d, unbedingt beim drehenden wrfel mal auskommentieren^^

setGLCLautokernel()                     ;CL-equipment initialisieren, kernel kompilieren usw

;bevor GL auf die Buffer zugreift, MUSS CL der Zugriff entzogen werden!!!
clFinish($command_queue)

;debugflag ausschalten 1=einschalten    ;erzeugt debugausgabe in der console
$CL_DEBUGFLAG = 0                       ;Debug-Ausgabe ausschalten, um Geschwindigkeit zu erhhen

glClear($GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT) ;Fenster clear
glLoadIdentity()                        ;Ersetzt die aktuelle Matrix durch die Einheitsmatrix
;gldisable($GL_CULL_FACE)
;
glTranslatef($width / 2, $height / 2, 0)

AdlibRegister("fps", 1000)              ;1x pro sekunde die FPS darstellen
_CL_SetArg(0, "ptr*", $writetoimage)    ;erstes argument fr den kernel ist das IMG
;hauptschleife
While glfwGetWindowParam($GLFW_OPENED) And Not glfwGetKey($GLFW_KEY_ESC);
    ; Sleep(10)
    glFlush()                           ;GL erlaubt CL den Zugriff auf die Buffer

    ;Kernel Parameter
    $steps += $step

    _CL_SetArg(1, "float*", $steps)     ;...und an kernel bergeben


    ;ACHTUNG, da SIMD-kernel, nur 1/4 der daten bentigt!!! s. $globalDS !!!!
    executeCLkernel()                   ;Opencl-kernel ausfhren, berechnet die Textur"pixel"

    ;glClear($GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT)             ;
    glBindTexture($GL_TEXTURE_2D, $textur1) ;

    glBegin($GL_QUADS)                  ;
    glTexCoord2f(0, 1)                  ;
    glVertex2f(-$width / 2, -$height / 2) ;
    glTexCoord2f(1, 1)                  ;
    glVertex2f(+$width / 2, -$height / 2) ;
    glTexCoord2f(1, 0)                  ;
    glVertex2f(+$width / 2, +$height / 2) ;
    glTexCoord2f(0, 0)                  ;
    glVertex2f(-$width / 2, +$height / 2) ;
    glEnd()                             ;
    glFlush()

    glfwSwapBuffers()                   ; Buffer tauschen.
    $fps += 1                           ;FPS FTW :o)

WEnd


; Aufrumen:
glDeleteTextures(1, $textur1)
glfwTerminate()
glTerminate()

;**********************Ende*********************




















