;#AutoIt3Wrapper_usex64=y
;9. Dezember 2012
#include <opencl_inc64.au3>
;Funktionen zum Vereinfachen der API-Calls

#include<array.au3>


Global $KernelSource, $context, $deviceid, $command_queue, $program, $kernel
Global $input_buffer_size, $output_buffer_size
Global $num_events_in_wait_list = 0, $event_wait_list = 0, $eventlist = _dllstructcreate16("uint_ptr[5]");struct
Global $num_platform
Global $num_device
Global $typ_device
Global $typ_device_CPUGPU
Global $name_device
Global $deviceid


Func _cl_GetDevice($device = "ALL", $num_device_used = 1, $num_platform_used = 1) ;
    If $num_device_used < 1 Or $num_device_used > 9 Or $num_platform_used < 1 Or $num_platform_used > 9 Then
        $num_device_used = 1
        $num_platform_used = 1
    EndIf
;~
    Local $numDevices                                             ;anzahl der Gerte
    Local $device_id, $devices                                    ;Gerte ID
    Local $num_platforms = 0                                      ; _dllstructcreate16("int_ptr");struct
    Dim $platform_device[10][10]

    ;zuerst alle verfgbaren platforms und devices bestimmen

    clGetPlatformIDs(10, $platforms, $num_platforms)
    If $num_platforms <= 0 Then
        MsgBox(0, "AutoIt OpenCl", "Sorry, no Device for OpenCl detected. Please istall the newest driver or/and the SDK from the vendor of your devices!")
        Exit
    EndIf
    Global $platform[$num_platforms + 1]

    ConsoleWrite(">Number Platforms = " & $num_platforms & @CRLF)

    For $i = 1 To $num_platforms                                  ;anzahl platforms und deren devices
        $platform[$i] = DllStructGetData($platforms, 1, $i)
        ;context erstellen, mit welchem Gert wird gearbeitet (CPU oder Grafikkarte)**********
        $context_properties = _dllstructcreate16("int_ptr[5]")    ;context-Eigenschaften
        DllStructSetData($context_properties, 1, $CL_CONTEXT_PLATFORM, 1)
        DllStructSetData($context_properties, 1, $platform[$i], 2) ;platform herraussuchen und damit die Berechnung durchfhren!
        DllStructSetData($context_properties, 1, 0, 3)
        DllStructSetData($context_properties, 1, 0, 4)
        DllStructSetData($context_properties, 1, 0, 5)
        ; DllStructSetData($context_properties, 1, $CL_CONTEXT_OFFLINE_DEVICES_AMD, 3)          ;$CL_CONTEXT_OFFLINE_DEVICES_AMD erlaubt das verwenden von binary kernels auf allen platformen
        ; DllStructSetData($context_properties, 1, 1, 4);wenn $CL_CONTEXT_OFFLINE_DEVICES_AMD verwendet wird
        $pfn_notify = _dllstructcreate16("int_ptr[5]")            ;keine callbackfunktion zum errorhandling der shaderfuncs
        $user_data = _dllstructcreate16("int_ptr")
        ;context anhand des Gertetyps erstellen
        $context = clCreateContextFromType($context_properties, $CL_DEVICE_TYPE_ALL, $pfn_notify, $user_data, $errcode_ret)

        ;Informationen uber das device holen
        $param_name = $CL_CONTEXT_DEVICES
        $devicelistsize = clGetContextInfo($context, $param_name, 0, 0, $param_value_size_ret); anzahl devices
        $devicelistsize = DllStructGetData($param_value_size_ret, 1, 1)
        $devices = _dllstructcreate16("int_ptr[" & $devicelistsize & "]") ;liste anlegen mit anzahl der devices
        $devicelistsize = clGetContextInfo($context, $param_name, $devicelistsize, DllStructGetPtr($devices), $param_value_size_ret);einzelne devices auflisten
        $devicelistsize = DllStructGetData($param_value_size_ret, 1, 1)
        $devicecount = $devicelistsize / 4 / (1 + @AutoItX64)     ;Anzahl devices

        ;Device (Gert) auswhlen
        For $numberdevice = 1 To $devicecount                     ;smtliche devices anzeigen
            $deviceid = DllStructGetData($devices, 1, $numberdevice) ;das Gert aus dieser Liste wird verwendet
            ;Typ (CPU/GPU) bestimmen (nur zur Info...)
            $param_name = $CL_DEVICE_TYPE                         ; Gertename anzeigen lassen
            $param_value_size = 8 * (1 + @AutoItX64)              ;gre des parameters in byte (int_ptr=4 byte)
            $para_struct = _dllstructcreate16("int_ptr[" & $param_value_size & "]")
            $device_info = clGetDeviceInfo($deviceid, $param_name, $param_value_size, DllStructGetPtr($para_struct), $param_value_size_ret)
            $devicetyp = DllStructGetData($para_struct, 1)        ;ergebnis aus der struct auslesen 2=CPU 4 = GPU
            Switch $devicetyp
                Case 2
                    $typ = "CPU"
                Case 4
                    $typ = "GPU"
                Case Else
                    $typ = $devicetyp & " unnknown"
            EndSwitch

            $param_name = $CL_DEVICE_NAME                         ;gesucht ist der Gertename
            $param_value_size = 200                               ;zeichenstring fr Gertenamen
            $para_struct = _dllstructcreate16("char[" & $param_value_size & "]") ;platz fr vendor-string
            $deviceid = DllStructGetData($devices, 1, $numberdevice) ;das Gert aus dieser Liste wird verwendet
            ;Gertenamen anzeigen lassen
            $device_info = clGetDeviceInfo($deviceid, $param_name, $param_value_size, DllStructGetPtr($para_struct), $param_value_size_ret)
            $infodevice = DllStructGetData($para_struct, 1)       ;das ist die rckgabe der clGetDeviceInfo()-Funktion!
            $platform_device[$i][$numberdevice] = $i & ";" & $numberdevice & ";" & $devicetyp & ";" & $typ & ";" & $infodevice & ";" & $deviceid & ";" & $platform[$i]

            ConsoleWrite('>Device verfgbar= ' & $platform_device[$i][$numberdevice] & @CRLF) ;### Debug Console
            _ArrayDisplay($platform_device[$i][$numberdevice])
        Next
    Next


    ;***************************************************
    ;verwendete platform und dessen device bestimmen

    If $platform_device[$num_platform_used][$num_device_used] = "" Then
        $a = StringSplit($platform_device[1][1], ";")             ;erstes verfgbares device
    Else
        If $num_platform_used = 1 And $num_device_used = 1 And $device <> "ALL" Then ;nchste CPU/GPU suchen
            For $p = 1 To 9
                For $d = 1 To 9
                    If $platform_device[$p][$d] <> "" Then        ;device gefunden
                        $a = StringSplit($platform_device[$p][$d], ";")
                        If $device = "CPU" And $a[4] = "CPU" Then ExitLoop 2 ;es wurde eine CPU ausgewhlt
                        If $device = "GPU" And $a[4] = "GPU" Then ExitLoop 2 ;es wurde eine CPU ausgewhlt
                    EndIf
                Next
            Next
        Else                                                      ;die $num_platform_used und $num_device_used werden verwendet, unabhngig von GPU/CPU
            $a = StringSplit($platform_device[$num_platform_used][$num_device_used], ";")
        EndIf
    EndIf
    $num_platform = $a[7]
    $num_device = $a[2]
    $typ_device = $a[3]
    ;    MsgBox(262144,'Debug line ~' & @ScriptLineNumber,'Selection:' & @lf & '$typ_device' & @lf & @lf & 'Return:' & @lf & $typ_device) ;### Debug MSGBOX
    $typ_device_CPUGPU = $a[4]
 ;   MsgBox(262144, 'Debug line ~' & @ScriptLineNumber, 'Selection:' & @LF & '$typ_device_CPUGPU' & @LF & @LF & 'Return:' & @LF & $typ_device_CPUGPU) ;### Debug MSGBOX
    $name_device = $a[5]
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $typ_device = ' & $typ_device & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $deviceid = $a[6]
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $deviceid = ' & $deviceid & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $num_device = ' & $num_device & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $num_platform = ' & $num_platform & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

    $context_properties = _dllstructcreate16("int_ptr[5]")        ;context-Eigenschaften
    DllStructSetData($context_properties, 1, $CL_CONTEXT_PLATFORM, 1)
    DllStructSetData($context_properties, 1, $num_platform, 2)    ;platform herraussuchen und damit die Berechnung durchfhren!
    DllStructSetData($context_properties, 1, 0, 3)
    DllStructSetData($context_properties, 1, 0, 4)
    DllStructSetData($context_properties, 1, 0, 5)
    ; DllStructSetData($context_properties, 1, $CL_CONTEXT_OFFLINE_DEVICES_AMD, 3)          ;$CL_CONTEXT_OFFLINE_DEVICES_AMD erlaubt das verwenden von binary kernels auf allen platformen
    ; DllStructSetData($context_properties, 1, 1, 4);wenn $CL_CONTEXT_OFFLINE_DEVICES_AMD verwendet wird
    $pfn_notify = _dllstructcreate16("int_ptr[5]")                ;keine callbackfunktion zum errorhandling der shaderfuncs
    $user_data = _dllstructcreate16("int_ptr")
    ;context anhand des Gertetyps erstellen
    $context = clCreateContextFromType($context_properties, $CL_DEVICE_TYPE_ALL, $pfn_notify, $user_data, $errcode_ret)


;~     $deviceid = DllStructGetData($devices, 1, $num_device)           ;das in der Funktion bergebene Gert wird verwendet
    ConsoleWrite("verwendetes Device  " & $platform_device[$num_platform_used][$num_device_used] & @CRLF)
    ;commandqueue erstellen
    $properties = $CL_QUEUE_PROFILING_ENABLE

    $queue_prop = _dllstructcreate16("int_ptr[5]")
    DllStructSetData($queue_prop, 1, 0, 1)
    DllStructSetData($queue_prop, 1, 0, 2)                        ;platform herraussuchen und damit die Berechnung durchfhren!
    DllStructSetData($queue_prop, 1, 0, 3)                        ;$CL_CONTEXT_OFFLINE_DEVICES_AMD)
    DllStructSetData($queue_prop, 1, 1, 4)
    DllStructSetData($queue_prop, 1, 0, 5)

    $devices_cl = _dllstructcreate16("int_ptr[5]")
    DllStructSetData($devices_cl, 1, $deviceid)
    $command_queue = clCreateCommandQueue($context, $deviceid, $properties, $errcode_ret)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $deviceid = ' & $deviceid & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

    ;programm aus kernelsource erstellen (integrierter compiler)
    $program = clCreateProgramWithSource($context, 1, $KernelSource, StringLen($KernelSource), $errcode_ret)
    ;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $program = ' & $program & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console

    ;programm vorkompilieren
    ;$num_devices = 1
    $param_name = $CL_CONTEXT_DEVICES
    $devicelistsize = clGetContextInfo($context, $param_name, 0, 0, $param_value_size_ret); anzahl devices
    $devicelistsize = DllStructGetData($param_value_size_ret, 1, 1)
    $devices = _dllstructcreate16("int_ptr[" & $devicelistsize & "]") ;liste anlegen mit anzahl der devices
    $devicelistsize = clGetContextInfo($context, $param_name, $devicelistsize, DllStructGetPtr($devices), $param_value_size_ret);einzelne devices auflisten
    $devicelistsize = DllStructGetData($param_value_size_ret, 1, 1)
    $devicecount = $devicelistsize / 4 / (1 + @AutoItX64)         ;Anzahl devices
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $devicecount = ' & $devicecount & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    ;clBuildProgram($program, $num_device, DllStructGetPtr($devices), 0, 0, 0)
    clBuildProgram($program, $num_device, DllStructGetPtr($devices), 0, 0, 0) ;nur fr das ausgewhlte device ein programm erstellen

    ;info des Compilers, es wird ein Log erstellt mit Fehlermeldungen
    ;ConsoleWrite("clGetProgramBuildInfo LOG" & @CRLF)
    $param_value = 0                                              ;_DllStructCreate16("uint")                                               ; rckgabe in $param_value_size_ret ist die Gre des logs in char
    $param_value_size = 0
    $param_name = $CL_PROGRAM_BUILD_LOG                           ;log des compilers aufrufen


    clGetProgramBuildInfo($program, $deviceid, $param_name, $param_value_size, $param_value, $param_value_size_ret)
    $logsize = DllStructGetData($param_value_size_ret, 1)         ;gre des logs
    $slog = _dllstructcreate16("char[" & $logsize & "]")          ;inhalt log
    clGetProgramBuildInfo($program, $deviceid, $param_name, $logsize, DllStructGetPtr($slog), $param_value_size_ret)
    $logsize = DllStructGetData($param_value_size_ret, 1)         ;gre des logs
    $log = DllStructGetData($slog, 1)
    If StringLen($log) > 1 Then ConsoleWrite("LOG: " & @CRLF & $log & @CRLF)


    ;Kernel erstellen fr jedes einzelne workitem
    ;kernelname extrahieren, der Kernelname steht idR vor der ffnenden Klammer, Regex needed^^
    $kname1 = StringInStr($KernelSource, "__kernel")
    $kname2 = StringInStr($KernelSource, "(", 0, 1, $kname1)
    $kname = StringSplit(StringStripWS(StringMid($KernelSource, $kname1, $kname2 - $kname1), 6), " ", 3)
    $kernel = clCreateKernel($program, $kname[UBound($kname) - 1], $errcode_ret)

    ;Anzahl der Workgroups bestimmen (nur zur Info...)
    $param_name = $CL_DEVICE_MAX_WORK_GROUP_SIZE                  ; Gesucht ist die maximale Anzahl Workgroups, von denen die Kernel abgearbeitet werden
    $param_value_size = 4 * (1 + @AutoItX64)                      ;gre des parameters in byte (uint=4 byte)
    $para_struct = _dllstructcreate16("uint[" & $param_value_size & "]") ;jaja...  :)...Speicherverschwender
    $device_info = clGetDeviceInfo($deviceid, $param_name, $param_value_size, DllStructGetPtr($para_struct), $param_value_size_ret)
    $MAX_WORK_GROUP_SIZE = DllStructGetData($para_struct, 1)      ;ergebnis aus der struct auslesen

    ;Anzahl der Compute-Units bestimmen (nur zur Info...)
    $param_name = $CL_DEVICE_MAX_compute_units                    ; Gertename anzeigen lassen
    $param_value_size = 4 * (1 + @AutoItX64)                      ;gre des parameters in byte (uint=4 byte)
    $para_struct = _dllstructcreate16("uint[" & $param_value_size & "]") ;jaja...  :)...Speicherverschwender
    $device_info = clGetDeviceInfo($deviceid, $param_name, $param_value_size, DllStructGetPtr($para_struct), $param_value_size_ret)
    $MAX_compute_units = DllStructGetData($para_struct, 1)        ;ergebnis aus der struct auslesen
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $MAX_compute_units = ' & $MAX_compute_units & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    ;Typ (CPU/GPU) bestimmen (nur zur Info...)
    $param_name = $CL_DEVICE_TYPE                                 ; Gertename anzeigen lassen
    $param_value_size = 8 * (1 + @AutoItX64)                      ;gre des parameters in byte (int_ptr=4 byte)
    $para_struct = _dllstructcreate16("int_ptr[" & $param_value_size & "]") ;jaja...  :)...Speicherverschwender
    $device_info = clGetDeviceInfo($deviceid, $param_name, $param_value_size, DllStructGetPtr($para_struct), $param_value_size_ret)
    $devicetyp = DllStructGetData($para_struct, 1)                ;ergebnis aus der struct auslesen
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $devicetyp = ' & $devicetyp & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    For $param_name = 0x0102b To 0x01031                          ;2b
        ; Info anzeigen lassen
        $param_value_size = 400                                   ;gre des parameters in byte (uint=4 byte)
        $para_struct = _dllstructcreate16("char[" & $param_value_size & "]") ;jaja...  :)...Speicherverschwender
        $device_info = clGetDeviceInfo($deviceid, $param_name, $param_value_size, DllStructGetPtr($para_struct), $param_value_size_ret)
        $info = DllStructGetData($para_struct, 1)                 ;ergebnis aus der struct auslesen
        ;    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $info = ' & $info & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
        ;     MsgBox(262144, 'Debug line ~' & @ScriptLineNumber, 'Selection:' & @LF & '$info' & @LF & @LF & 'Return:' & @LF & $info) ;### Debug MSGBOX
    Next

EndFunc                                                           ;==>_cl_GetDevice


Func _CL_CreateBuffer($buffer)
    $flags = BitOR($CL_MEM_READ_WRITE, $CL_MEM_use_HOST_PTR)
    $buffer_size = DllStructGetSize($buffer)
    $host_ptr = DllStructGetPtr($buffer)
    Return clCreateBuffer($context, $flags, $buffer_size, $host_ptr, $errcode_ret)
EndFunc                                                           ;==>_CL_CreateBuffer

Func _CL_WriteBuffer($CL_buffer, $write_buffer)
    Return clEnqueueWriteBuffer($command_queue, $CL_buffer, $CL_true, 0, DllStructGetSize($write_buffer), DllStructGetPtr($write_buffer), $num_events_in_wait_list, $event_wait_list, $eventlist)
EndFunc                                                           ;==>_CL_WriteBuffer

Func _CL_ReadBuffer($CL_buffer, $read_buffer)
    Return clEnqueueReadBuffer($command_queue, $CL_buffer, $CL_true, 0, DllStructGetSize($read_buffer), DllStructGetPtr($read_buffer), $num_events_in_wait_list, $event_wait_list, $eventlist)
EndFunc                                                           ;==>_CL_ReadBuffer

Func _CL_SetArg($arg_index, $arg_type, $arg_value)
    Local $struct = DllStructCreate(StringReplace($arg_type, "*", ""))
    ;    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : DllStructGetSize($struct) = ' & DllStructGetSize($struct) & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console
    Return clSetKernelArg($kernel, $arg_index, DllStructGetSize($struct), $arg_type, $arg_value)
EndFunc                                                           ;==>_CL_SetArg

Func _CL_RunKernel($global, $local)
    $globalDS = _dllstructcreate16("uint_ptr")
    DllStructSetData($globalDS, 1, $global)
    $localDS = _dllstructcreate16("uint_ptr")
    DllStructSetData($localDS, 1, $local)
    If $local <> 0 Then
        $localWS = DllStructGetPtr($localDS)
    Else
        $localWS = 0                                              ;OpenCl ermittelt selbststndig eine Workgroupsize
    EndIf
    $work_dim = 1
    Return clEnqueueNDRangeKernel($command_queue, $kernel, $work_dim, 0, DllStructGetPtr($globalDS), $localWS, $num_events_in_wait_list, $event_wait_list, $eventlist)
EndFunc                                                           ;==>_CL_RunKernel


Func profile_cl_event()
    clWaitForEvents(1, DllStructGetPtr($eventlist))
    $event = DllStructGetData($eventlist, 1, 1)
    $param_name = $CL_PROFILING_COMMAND_START
    $starttime = _dllstructcreate16("int64")                     ;c++ ulong = INT64
    $param_value_size = DllStructGetSize($starttime)
    clGetEventProfilingInfo($event, $param_name, $param_value_size, DllStructGetPtr($starttime), 0)
    $start = DllStructGetData($starttime, 1, 1)

    $param_name = $CL_PROFILING_COMMAND_END
    $endtime = _dllstructcreate16("int64")                       ;c++ ulong = INT64
    $param_value_size = DllStructGetSize($endtime)
    clGetEventProfilingInfo($event, $param_name, $param_value_size, DllStructGetPtr($endtime), 0)
    $end = DllStructGetData($endtime, 1, 1)

    Return ($end - $start) / 1e6                                 ;zeit in millisekunden
EndFunc                                                          ;==>profile_cl_event




























