#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#region                                                              ;**** Directives created by AutoIt3Wrapper_GUI ****
#endregion                                                           ;**** Directives created by AutoIt3Wrapper_GUI ****
#include "..\Includes\opengl.au3"
#include <opencl_easy.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <GDIConstants.au3>
#include <Misc.au3>

;INFOS!!!
;erst textur in openGL erstellen und binden, dann erst CL-context erstellen


$CL_DEBUGFLAG = 1                                                    ;1 debug aus


$width = 512 + 256
$height = 512 + 256


Global $glew_hDLL = DllOpen("glew32.dll")

Global $num_events_in_wait_list = 0, $event_wait_list = 0, $eventlist = _dllstructcreate16("uint_ptr[5]");struct
global $bufferdatasize = $width * $height * 4                                         ;4x float = 16 bytest
Global Const $GL_ARRAY_BUFFER = 0x8892
global const $GL_DYNAMIC_DRAW = 0x88E8


Global $KernelSource = "__kernel void tunnelflug( write_only image2d_t output,const float stepx)" & @CRLF & _
        "{" & @CRLF & _
        "float x = get_global_id(0), y = get_global_id(1);" & @CRLF & _         ;thread-id, d.h. jedes pixel von 1 bis b*h
        "float width = get_global_size(0), height = get_global_size(1);" & @CRLF & _           ;pixelkoordinaten
        "float dy      = (y / height) - 0.5f;" & @CRLF & _            ;...Berechnungen
        "float dx      = (x / width) - 0.5f;" & @CRLF & _
        "float wurzel  = sqrt(dy * dy + dx * dx);" & @CRLF & _
        "int tu        = 203.718330624f * atan2(dy ,dx);" & @CRLF & _
        "int tv        = (((100 / wurzel) + stepx));" & @CRLF & _
        "int t         = (tu^tv)&255;" & @CRLF & _                    ;farbe pixel
        "float4 farbe;" & @CRLF & _                                     ;farbe pixel
        "farbe.x = (float) t / 256.0f ;" & @CRLF & _                                   ;farbe pixel
        "farbe.y = (float) t / 256.0f ;" & @CRLF & _                                    ;farbe pixel
        "farbe.z = (float) t / 256.0f ;" & @CRLF & _                                    ;farbe pixel
        "farbe.w = 0.0f;" & @CRLF & _                                    ;farbe pixel
        "write_imagef( output, (int2)( x, y ), farbe );" & @CRLF & _  ;Pixel schreiben 0xFFBBGGRR, BB=GG=RR=t
        "}"

;~ $KernelSource = FileRead("simple.cl")
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $KernelSource = ' & $KernelSource & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console



$Typ = "GPU"


;GL und extensions initialisieren
glInit()
gluInit()
glfwInit()

;Fenster einrichten
glfwOpenWindowHint($GLFW_WINDOW_NO_RESIZE, 1)                        ; Resize nicht mglich
glfwOpenWindow($width, $height, 8, 8, 8, 0, 8, 0, $GLFW_WINDOW)      ; Fenster ffnen
glfwSetWindowTitle("Tunnelflug ")                                    ; Titel setzen

;GL-context holen
$ctx = wglGetCurrentContext()
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ctx = ' & $ctx & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;GL-DC vom Fenster holen
$hdc = wglGetCurrentDC()
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $hdc = ' & $hdc & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;jetzt erst glew initialisieren!
$init = glewinit()
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & glewGetErrorString($init) & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;Context an aktuellen DC binden
$err = wglMakeCurrent($hdc, $ctx)
If $err = 0 Then
    MsgBox(0, "    wglMakeCurrent", "Error!")
    Exit
EndIf


;GL-Version berprfen
$erg = _glewIsSupported("GL_VERSION_2_0")
$erg1 = _glewIsSupported("GL_ARB_pixel_buffer_object")
If $erg = False Or $erg1 = False Then
    MsgBox(0, "GLEW", "GL_VERSION_2_0 or GL_ARB_pixel_buffer_object is not supported!")
    Exit
EndIf

;08/15 GL-Kram....
glEnable($GL_TEXTURE_2D)                                             ;
glClearColor(0.0, 0.0, 0.0, 1.0)                                     ;
glDisable($GL_DEPTH_TEST)                                            ;
glViewport(0, 0, $width, $height)                                    ;
glMatrixMode($GL_PROJECTION)                                         ;
glLoadIdentity()                                                     ;
;gluPerspective(60.0,$wIDTH / $HEIGHT,0.1,10.0);

;leere textur erstellen
$textur1 = glgentextures(1)                                          ;
glBindTexture($GL_TEXTURE_2D, $textur1)

;Eigenschaften der Textur definieren
glTexImage2d($GL_TEXTURE_2D, 0, $GL_RGBA, $width, $height, 0, $GL_RGBA, $GL_UNSIGNED_BYTE, 0);
glTexParameteri($GL_TEXTURE_2D, $GL_TEXTURE_WRAP_S, $GL_CLAMP)       ;
glTexParameteri($GL_TEXTURE_2D, $GL_TEXTURE_WRAP_T, $GL_CLAMP)       ;
glTexParameteri($GL_TEXTURE_2D, $GL_TEXTURE_MAG_FILTER, $GL_LINEAR)  ;
glTexParameteri($GL_TEXTURE_2D, $GL_TEXTURE_MIN_FILTER, $GL_LINEAR)  ;


;glEnable($GL_TEXTURE_2D)                                             ;                         Texture Mapping
;glBlendFunc($GL_SRC_ALPHA, $GL_ONE)                                   ;                Blenden
;glClearColor(.5, .5, 0.5, 0.5)                                        ;             Grau
;glClearDepth(1.0)                                                     ;                                  Depth Buffer
;glDepthFunc($GL_LEQUAL)                                               ;                          Depthbuffer Typ
;glEnable($GL_DEPTH_TEST)                                              ;
;glShadeModel($GL_SMOOTH)                                              ;
;glHint($GL_PERSPECTIVE_CORRECTION_HINT, $GL_NICEST)                   ;


;Buffer erstellen....
$vertexobj_struct = DllStructCreate("int[100]")
$vertexobj_ptr = DllStructGetPtr($vertexobj_struct)

;bufferhandle holen
$genbuff = glewGenBuffers(1, $vertexobj_ptr)                         ;
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $genbuff = ' & $genbuff & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $genbuff = ' & glewGetErrorString($genbuff) & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
$vertexObj = DllStructGetData($vertexobj_struct, 1, 1)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $vertexObj = ' & $vertexObj & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;.....und an den arraybuffer binden
$bind = glBindBuffer($GL_ARRAY_BUFFER, $vertexObj)                   ;
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $bind = ' & $bind & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;Buffergrsse und pointer festlegen und an arraybuffer binden
$struct = _dllstructcreate16("float[" & $bufferdatasize & "]");width * height * 4
$fdata = DllStructGetPtr($struct)
$a = glewBufferData($GL_ARRAY_BUFFER, $bufferdatasize, $fdata, $GL_DYNAMIC_DRAW);
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : glewbufferdata = ' & glewGetErrorString($a) & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


;08/15 GL-Kram....
glViewport(0, 0, $width, $height)                                    ;
glMatrixMode($GL_PROJECTION)                                         ;  Sichtmatrix
glLoadIdentity()                                                     ;
;gluPerspective(45.0, 500/500, 0.1, 100.0);

glOrtho(0, $width, 0, $height, 0, 128)                               ;
glMatrixMode($GL_MODELVIEW)                                          ;     Modelmatrix
glLoadIdentity()                                                     ;

;wichtig! bevor CL auf die shader/Buffer/irgendetwas von GL zugreift.
;es knnen NIE GL und CL gleichzeitig auf Daten zugreifen, immer nur exclusiv entweder GL oder CL
glFinish()



;*************************
;
;          CL
;
;*************************


Local $numDevices                                                    ;anzahl der Gerte
Local $device_id, $devices                                           ;Gerte ID
Local $num_platforms = 0                                             ; _dllstructcreate16("int_ptr");struct
Dim $platform_device[10][10]

;zuerst alle verfgbaren platforms und devices bestimmen
clGetPlatformIDs(10, $platforms, $num_platforms)
If $num_platforms <= 0 Then
    MsgBox(0, "AutoIt OpenCl", "Sorry, no Device for OpenCl detected. Please istall the newest driver or/and the SDK from the vendor of your devices!")
    Exit
EndIf
Global $platform[$num_platforms + 1]

ConsoleWrite(">Number Platforms = " & $num_platforms & @CRLF)

$num_platform = 1                                                               ;anzahl platforms und deren devices
$platform[$num_platform] = DllStructGetData($platforms, 1, $num_platform)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $platform[$i] = ' & $platform[$num_platform] & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;context erstellen, mit welchem Gert wird gearbeitet (CPU oder Grafikkarte)**********




$context_properties = _dllstructcreate16("int_ptr[10]")              ;context-Eigenschaften
DllStructSetData($context_properties, 1, $CL_CONTEXT_PLATFORM, 1)
DllStructSetData($context_properties, 1, $platform[$num_platform], 2)           ;platform herraussuchen und damit die Berechnung durchfhren!
DllStructSetData($context_properties, 1, $CL_GL_CONTEXT_KHR, 3)
DllStructSetData($context_properties, 1, $ctx, 4)
DllStructSetData($context_properties, 1, $CL_WGL_HDC_KHR, 5)
DllStructSetData($context_properties, 1, $hdc, 6)
DllStructSetData($context_properties, 1, 0, 7)
DllStructSetData($context_properties, 1, 0, 8)

$dev = $CL_DEVICES_FOR_GL_CONTEXT_KHR
;$dev=$CL_CURRENT_DEVICE_FOR_GL_CONTEXT_KHR

$ret = clGetGLContextInfoKHR($context_properties, $dev, 0, 0, $param_value_size_ret)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
$devicelistsize = DllStructGetData($param_value_size_ret, 1, 1)      ;/ 4 / (1 + @AutoItX64)
;MsgBox(262144,'Debug line ~' & @ScriptLineNumber,'Selection:' & @lf & '$devicelistsize' & @lf & @lf & 'Return:' & @lf & $devicelistsize) ;### Debug MSGBOX
$devices = _dllstructcreate16("int_ptr[" & $devicelistsize & "]")    ;liste anlegen mit anzahl der devices



$ret = clGetGLContextInfoKHR($context_properties, $dev, $devicelistsize, DllStructGetPtr($devices), $NULL)
;~     $deviceid = DllStructGetData($devices, 1, 1)
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $deviceid = ' & $deviceid & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console



For $i = 1 To $devicelistsize
    $a = DllStructGetData($devices, 1, $i)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $a = ' & $a & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Consolenext
Next






If $Typ = "GPU" Then

    $ret = clGetGLContextInfoKHR($context_properties, $CL_CURRENT_DEVICE_FOR_GL_CONTEXT_KHR, $devicelistsize, DllStructGetPtr($devices), $NULL)
    $deviceid = DllStructGetData($devices, 1, 1)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $deviceid = ' & $deviceid & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


    $pfn_notify = _dllstructcreate16("int_ptr[5]")                   ;keine callbackfunktion zum errorhandling der shaderfuncs
    $device_struct = _dllstructcreate16("int_ptr")
    $context = clcreatecontext($context_properties, 1, $devices, $NULL, $NULL, $errcode_ret)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $context = ' & $context & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $num_device = 1
Else

    $pfn_notify = _dllstructcreate16("int_ptr[5]")                   ;keine callbackfunktion zum errorhandling der shaderfuncs
    $user_data = _dllstructcreate16("int_ptr")
    ;context anhand des Gertetyps erstellen

    ; $context = clcreatecontext($context_properties, 1, $devices, $NULL, $NULL, $errcode_ret)
    $context = clCreateContextFromType($context_properties, $CL_DEVICE_TYPE_CPU, $pfn_notify, $user_data, $errcode_ret)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $context = ' & $context & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $deviceid = DllStructGetData($devices, 1, 2)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $deviceid = ' & $deviceid & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $num_device = 1
EndIf



If $Typ = "CPU" Then                                                 ;deviceid holen
;~ ;
    $device_type = $CL_DEVICE_TYPE_CPU
    $plat = $platform[1]
    $num_entries = 0
    $devices = _dllstructcreate16("int_ptr[5]")
    $num_devices = _dllstructcreate16("int_ptr")
    $ret = clGetDeviceIDs($plat, $device_type, $num_entries, 0, DllStructGetPtr($num_devices));anzahl der devices holen
    $anz_devices = DllStructGetData($num_devices, 1, 1)              ;/ 4 / (1 + @AutoItX64)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : @AutoItX64 = ' & @AutoItX64 & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $anz_devices = ' & $anz_devices & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $devices = _dllstructcreate16("int_ptr[" & $anz_devices & "]")
    $ret = clGetDeviceIDs($plat, $device_type, $anz_devices, DllStructGetPtr($devices), 0);device-ids holen
    $deviceid = DllStructGetData($devices, 1, 1)                     ;nummer des device holen
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $deviceid = ' & $deviceid & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

EndIf






$properties = $CL_QUEUE_PROFILING_ENABLE
$command_queue = clCreateCommandQueue($context, $deviceid, $properties, $errcode_ret)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $command_queue = ' & $command_queue & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


;~ $a = glewGetErrorString($ret)
;~ ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $a = ' & $a & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


$posBuf = clCreateFromGLBuffer($context, $CL_MEM_WRITE_ONLY, $vertexObj, $errcode_ret);
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $posBuf = ' & $posBuf & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console




;programm aus kernelsource erstellen (integrierter compiler)
$program = clCreateProgramWithSource($context, 1, $KernelSource, StringLen($KernelSource), $errcode_ret)
;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $program = ' & $program & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console

;programm vorkompilieren

;~ $num_device = 1
;~ $param_name = $CL_CONTEXT_DEVICES
;~ $devicelistsize = clGetContextInfo($context, $param_name, 0, 0, $param_value_size_ret); anzahl devices
;~ $devicelistsize = DllStructGetData($param_value_size_ret, 1, 1)
;~ $devices = _dllstructcreate16("int_ptr[" & $devicelistsize & "]")     ;liste anlegen mit anzahl der devices
;~ $devicelistsize = clGetContextInfo($context, $param_name, $devicelistsize, DllStructGetPtr($devices), $param_value_size_ret);einzelne devices auflisten
;~ $devicelistsize = DllStructGetData($param_value_size_ret, 1, 1)
;~ $devicecount = $devicelistsize / 4 / (1 + @AutoItX64)                 ;Anzahl devices
;~ ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $devicecount = ' & $devicecount & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;~ ;    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $devicecount = ' & $devicecount & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;~ ;clBuildProgram($program, $num_device, DllStructGetPtr($devices), 0, 0, 0)


clBuildProgram($program, $num_device, DllStructGetPtr($devices), 0, 0, 0) ;nur fr das ausgewhlte device ein programm erstellen

;info des Compilers, es wird ein Log erstellt mit Fehlermeldungen
;ConsoleWrite("clGetProgramBuildInfo LOG" & @CRLF)
$param_value = 0                                                     ;_DllStructCreate16("uint")                                               ; rckgabe in $param_value_size_ret ist die Gre des logs in char
$param_value_size = 0
$param_name = $CL_PROGRAM_BUILD_LOG                                  ;log des compilers aufrufen


clGetProgramBuildInfo($program, $deviceid, $param_name, $param_value_size, $param_value, $param_value_size_ret)
$logsize = DllStructGetData($param_value_size_ret, 1)                ;gre des logs
$slog = _dllstructcreate16("char[" & $logsize & "]")                 ;inhalt log
clGetProgramBuildInfo($program, $deviceid, $param_name, $logsize, DllStructGetPtr($slog), $param_value_size_ret)
$logsize = DllStructGetData($param_value_size_ret, 1)                ;gre des logs
$log = DllStructGetData($slog, 1)
If StringLen($log) > 1 Then ConsoleWrite("LOG: " & @CRLF & $log & @CRLF)


;Kernel erstellen fr jedes einzelne workitem
;kernelname extrahieren, der Kernelname steht idR vor der ffnenden Klammer, Regex needed^^
$kname1 = StringInStr($KernelSource, "__kernel")
$kname2 = StringInStr($KernelSource, "(", 0, 1, $kname1)
$kname = StringSplit(StringStripWS(StringMid($KernelSource, $kname1, $kname2 - $kname1), 6), " ", 3)
$kernel = clCreateKernel($program, $kname[UBound($kname) - 1], $errcode_ret)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $kernel = ' & $kernel & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;*************************************************************************************************************************

;CL_DEVICE_NAME


$param_name = $CL_DEVICE_MAX_WORK_GROUP_SIZE                         ; Gesucht ist die maximale Anzahl Workgroups, von denen die Kernel abgearbeitet werden
$param_value_size = 4 * (1 + @AutoItX64)                             ;gre des parameters in byte (uint=4 byte)
$para_struct = _dllstructcreate16("uint[" & $param_value_size & "]") ;jaja...  :)...Speicherverschwender
$device_info = clGetDeviceInfo($deviceid, $param_name, $param_value_size, DllStructGetPtr($para_struct), $param_value_size_ret)
$MAX_WORK_GROUP_SIZE = DllStructGetData($para_struct, 1)             ;ergebnis aus der struct auslesen
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $MAX_WORK_GROUP_SIZE = ' & $MAX_WORK_GROUP_SIZE & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


;*************************************************************************************************************************


ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $GL_TEXTURE_2D = ' & $GL_TEXTURE_2D & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $CL_MEM_WRITE_ONLY = ' & $CL_MEM_WRITE_ONLY & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

$writetoimage = clCreateFromGLTexture2D($context, $CL_MEM_WRITE_ONLY, $GL_TEXTURE_2D, 0, $textur1, $errcode_ret)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $writetoimage = ' & $writetoimage & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

clFinish($command_queue)


gldisable($GL_CULL_FACE)
glClear($GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT)                 ;
$a = 0
Global $fps = 0
AdlibRegister("fps", 1000)



$globalDS = _dllstructcreate16("uint_ptr[2]")
DllStructSetData($globalDS, 1, $width, 1)
DllStructSetData($globalDS, 1, $height, 2)
$localDS = _dllstructcreate16("uint_ptr[2]")



DllStructSetData($localDS, 1, $MAX_WORK_GROUP_SIZE, 1)
DllStructSetData($localDS, 1, 1, 2)


$localWS = 0                                                         ;DllStructGetPtr($localDS)

$work_dim = 2

$CL_DEBUGFLAG = 0                                                    ;Debug-Ausgabe ausschalten, um Geschwindigkeit zu erhhen
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $CL_DEBUGFLAG = ' & $CL_DEBUGFLAG & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

_CL_SetArg(0, "ptr*", $writetoimage)
$step = 1.02                                                         ;das ist die Schrittweite, um die der Tunnelflug ein Frame weiter gezeichnet wird
$steps = 0                                                           ;Beginn des Fluges...


glLoadIdentity()                                                     ;
glTranslatef($width / 2, $height / 2, 0)
global $m
$diffrun=0
While glfwGetWindowParam($GLFW_OPENED) And Not glfwGetKey($GLFW_KEY_ESC)
   ; glFlush()
    ;glFinish()
    $steps += $step
    _CL_SetArg(1, "float*", $steps)                                  ;...und an kernel bergeben



$t=timerinit()
    $aquire = clEnqueueAcquireGLObjects($command_queue, 1, $posBuf, $num_events_in_wait_list, $event_wait_list, $eventlist);
    ;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $aquire = ' & $aquire & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;$diffrun += profile_cl_event()
    ;$time += 0.01
    ;_CL_SetArg(3, "float*", $time)




    $kernelenqueue = clEnqueueNDRangeKernel($command_queue, $kernel, $work_dim, 0, DllStructGetPtr($globalDS), $localWS, $num_events_in_wait_list, $event_wait_list, $eventlist)
    ;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $kernelenqueue = ' & $kernelenqueue & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
;$diffrun += profile_cl_event()

    $flush = clFlush($command_queue)                                 ;
    ;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $flush = ' & $flush & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    ;sleep(10)

    $release = clEnqueueReleaseGLObjects($command_queue, 1, $posBuf, $num_events_in_wait_list, $event_wait_list, $eventlist);
    ;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $release = ' & $release & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

    ;$finish = clFinish($command_queue)                               ;
    ;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $finish = ' & $finish & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

$m=timerdiff($t)
;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $m = ' & $m & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console



    ;glClear($GL_COLOR_BUFFER_BIT + $GL_DEPTH_BUFFER_BIT);
;~         glLoadIdentity()                                              ;
;~         glTranslatef(256, 256, 0)                                     ;




    glBindTexture($GL_TEXTURE_2D, $textur1)                          ;
;~ if $a=1 then
;~ $a=0
;~ else
;~ $a=1
;~ endif
    $b = $width
    $h = $height

    glBegin($GL_QUADS)                                               ;
    glTexCoord2f(0, 1)                                               ;
    glVertex2f(-$b / 2, -$h / 2)                                     ;
    glTexCoord2f(1, 1)                                               ;
    glVertex2f(+$b / 2, -$h / 2)                                     ;
    glTexCoord2f(1, 0)                                               ;
    glVertex2f(+$b / 2, +$h / 2)                                     ;
    glTexCoord2f(0, 0)                                               ;
    glVertex2f(-$b / 2, +$h / 2)                                     ;
    glEnd()                                                          ;
    glFlush()

    glfwSwapBuffers()                                                ; Buffer tauschen.
    $fps += 1

WEnd



; Aufrumen:
glDeleteTextures(1, $textur1)
glfwTerminate()
glTerminate()



Func fps()
    glfwSetWindowTitle("Tunnelflug " & $fps & " FPS    Kerneltime: "&$m&" ms");
	;glfwSetWindowTitle("Tunnelflug " & $fps & " FPS    Kerneltime: "&($diffrun/$fps)&" ms")
    ; ToolTip($fps)
    $fps = 0
	$diffrun=0
EndFunc                                                              ;==>fps




Func SwapBuffers($DC)                                                ;
    $ret = DllCall('gdi32.dll', 'ptr', 'SwapBuffers', 'hwnd', $DC)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    Return $ret[0]
EndFunc                                                              ;==>SwapBuffers



Func clGetExtensionFunctionAddress($str)
    Local $ret = DllCall($OpenCl_dll, "ptr", "clGetExtensionFunctionAddress", "str", $str)
    If @error Then Return SetError(@error, @extended, $ret)
    ; ---
    Return $ret[0]
EndFunc                                                              ;==>clGetExtensionFunctionAddress



Func _glewGetExtension($str)
    Local $ret = DllCall($glew_hDLL, "ptr", "_glewGetExtension@4", "str", $str)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret[0] & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    ; _ArrayDisplay($ret)
    If @error Then Return SetError(@error, @extended, $ret)
    ; ---
    Return $ret[0]
EndFunc                                                              ;==>_glewGetExtension



Func wglGetCurrentDC()
    Local $ret = DllCall($__GL_hDLL, "uint", "wglGetCurrentDC")
    If @error Then Return SetError(@error, @extended, $ret)
    ; ---
    Return $ret[0]
EndFunc                                                              ;==>wglGetCurrentDC


Func wglGetCurrentContext()
    Local $ret = DllCall($__GL_hDLL, "uint", "wglGetCurrentContext")
    If @error Then Return SetError(@error, @extended, $ret)
    ; ---
    Return $ret[0]
EndFunc                                                              ;==>wglGetCurrentContext







Func clCreateContext($context_prop, $device_number, $device, $pfn_notify, $user_data, $errcode_ret)
    $aCall = DllCall($OpenCl_dll, "int_ptr", "clCreateContext", "int_ptr", DllStructGetPtr($context_prop), "int_ptr", $device_number, "int_ptr", DllStructGetPtr($device), "int_ptr", $pfn_notify, "int_ptr", $user_data, "int_ptr", DllStructGetPtr($errcode_ret))
    ; _ArrayDisplay($aCall)
    If $CL_DEBUGFLAG Then
        If @error Then
            MsgBox(0, 'Error in Function ''clCreateContext''   DllCall() failed', ' Returncode ' & @error)
            Return SetError(1, 0, -1)
        EndIf
        If OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)) <> 'CL_SUCCESS' Then
            MsgBox(0, 'Error in Function clCreateContext', '  Returncode: ' & OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)))
        Else
            ConsoleWrite('clCreateContext  CL_SUCCESS' & @CRLF)
        EndIf
    EndIf
    Return $aCall[0]
EndFunc                                                              ;==>clCreateContext



Func _CreateNewBmp32($iwidth, $iheight, ByRef $ptr, ByRef $hbmp)     ;erstellt leere 32-bit-Bitmap; Rckgabe DC und ptr und handle auf die Bitmapdaten
    ;by Andy
    Local $hcdc = _WinAPI_CreateCompatibleDC(0)                      ;Desktop-Kompatiblen DeviceContext erstellen lassen
    Local $tBMI = DllStructCreate($tagBITMAPINFO)                    ;Struktur der Bitmapinfo erstellen und Daten eintragen
    DllStructSetData($tBMI, "Size", DllStructGetSize($tBMI) - 4)     ;Structgre abzglich der Daten fr die Palette
    DllStructSetData($tBMI, "Width", $iwidth)
    DllStructSetData($tBMI, "Height", -$iheight)                     ;minus =standard = bottomup
    DllStructSetData($tBMI, "Planes", 1)
    DllStructSetData($tBMI, "BitCount", 32)                          ;32 Bit = 4 Bytes => AABBGGRR
    Local $adib = DllCall('gdi32.dll', 'ptr', 'CreateDIBSection', 'hwnd', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', $DIB_RGB_COLORS, 'ptr*', 0, 'ptr', 0, 'uint', 0)
    $hbmp = $adib[0]                                                 ;hbitmap handle auf die Bitmap, auch per GDI+ zu verwenden
    $ptr = $adib[4]                                                  ;pointer auf den Anfang der Bitmapdaten, vom Assembler verwendet
    _WinAPI_SelectObject($hcdc, $hbmp)                               ;objekt hbitmap in DC
    Return $hcdc                                                     ;DC der Bitmap zurckgeben
EndFunc                                                              ;==>_CreateNewBmp32




Func clGetGLContextInfoKHR($context_prop, $device_type, $param_value_size, $param_value, ByRef $param_value_size_ret)
    $clGetGLContextInfoKHR = clGetExtensionFunctionAddress("clGetGLContextInfoKHR")
    ;    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $clGetGLContextInfoKHR = ' & $clGetGLContextInfoKHR & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console

    $aCall = DllCallAddress("int_ptr", $clGetGLContextInfoKHR, "int_ptr", DllStructGetPtr($context_prop), "int_ptr", $device_type, "int_ptr", $param_value_size, "int_ptr", $param_value, "int_ptr", DllStructGetPtr($param_value_size_ret))
    ;    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $aCall = ' & $aCall & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console
    If $CL_DEBUGFLAG Then
        If @error Then
            MsgBox(0, 'Error in Function ''clGetGLContextInfoKHR''   DllCall() failed', ' Returncode ' & @error)
            Return SetError(1, 0, -1)
        EndIf
        If OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)) <> 'CL_SUCCESS' Then
            MsgBox(0, 'Error in Function clCreateContext', '  Returncode: ' & OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)))
        Else
            ConsoleWrite('clGetGLContextInfoKHR  CL_SUCCESS' & @CRLF)
        EndIf
    EndIf
    ;    _arraydisplay($acall)
    Return $aCall[5]

EndFunc                                                              ;==>clGetGLContextInfoKHR


Func wglcreatecontext($hwnd)
    Local $ret = DllCall($__GL_hDLL, "ptr", "wglCreateContext", "hwnd", $hwnd)
    If @error Then Return SetError(@error, @extended, $ret)
    ; ---
    Return $ret[0]
EndFunc                                                              ;==>wglcreatecontext




Func wglMakeCurrent($hdc, $hrc)
    Local $ret = DllCall($__GL_hDLL, "bool", "wglMakeCurrent", "hwnd", $hdc, "ptr", $hrc)
    ;_ArrayDisplay($ret)
    If @error Then Return SetError(@error, @extended, $ret)
    ; ---
    Return $ret[0]
EndFunc                                                              ;==>wglMakeCurrent


Func _ChoosePixelFormat($hdc, ByRef $ppfd)
;~     http://msdn.microsoft.com/en-us/library/ms537556(VS.85).aspx
    Local $ret = DllCall('Gdi32.dll', 'int', 'ChoosePixelFormat', _
            'hwnd', $hdc, _
            'ptr', DllStructGetPtr($ppfd))
    Return $ret[0]
EndFunc                                                              ;==>_ChoosePixelFormat

Func _SetPixelFormat($hdc, $iPixelFormat, ByRef $ppfd)
;~     http://msdn.microsoft.com/en-us/library/ms537559(VS.85).aspx
    Local $ret = DllCall('Gdi32.dll', 'int', 'SetPixelFormat', _
            'hwnd', $hdc, _
            'int', $iPixelFormat, _
            'ptr', DllStructGetPtr($ppfd))
    Return $ret[0]
EndFunc                                                              ;==>_SetPixelFormat

Func _wglCreateContext($hdc)
;~     http://msdn.microsoft.com/en-us/library/ms537549(VS.85).aspx
    Local $ret = DllCall('opengl32.dll', 'ptr', 'wglCreateContext', _
            'hwnd', $hdc)
    Return $ret[0]
EndFunc                                                              ;==>_wglCreateContext

Func glTexImage2D($target, $level, $internalFormat, $width, $height, $border, $format, $type, $ptr_data)
    Local $ret = DllCall('opengl32.dll', 'int', 'glTexImage2D', "int", $target, "int", $level, "int", $internalFormat, "int", $width, "int", $height, "int", $border, "int", $format, "int", $type, "ptr", $ptr_data)
    Return $ret[0]
EndFunc                                                              ;==>glTexImage2D

Func _wglDeleteContext($hglrc)
;~     http://msdn.microsoft.com/en-us/library/ms537548(VS.85).aspx
    Local $ret = DllCall('opengl32.dll', 'int', 'wglDeleteContext', _
            'ptr', $hglrc)
    Return $ret[0]
EndFunc                                                              ;==>_wglDeleteContext


Func wglGetProcAddress($string)
    Local $ret = DllCall($__GL_hDLL, "ptr", "wglGetProcAddress", "str", $string)
    ;ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    ;_ArrayDisplay($ret)
    If @error Then Return SetError(@error, @extended, $ret)
    ; ---
    Return $ret[0]
EndFunc                                                              ;==>wglGetProcAddress

Func glewGetErrorString($nr)
    $aCall = DllCall($glew_hDLL, "str", "_glewGetErrorString@4", 'int', $nr)
    Return $aCall[0]
EndFunc                                                              ;==>glewGetErrorString

Func glewGenBuffers($nr, $ptr)                                       ; by Andy@autoit.de
    $aCall = DllCallAddress("int", get_glew_address("__glewGenBuffers"), "int", 1, "uint", $ptr)
    Return $aCall[0]
EndFunc                                                              ;==>glewGenBuffers


Func glBindBuffer($target, $buffer)                                  ; by Andy@autoit.de
    $aCall = DllCallAddress("int", get_glew_address("__glewBindBuffer"), "int", $target, "uint", $buffer)
    Return $aCall[0]
EndFunc                                                              ;==>glBindBuffer



Func glewBufferData($target, $size, $data, $usage)                   ; by Andy@autoit.de
    $aCall = DllCallAddress("int", get_glew_address("__glewBufferData"), "uint", $target, "uint", $size, "ptr", $data, "uint", $usage)
    Return $aCall[0]
EndFunc                                                              ;==>glewBufferData



Func glewInit()

    Local $ret = DllCall($glew_hDLL, "int", "_glewInit@0")
    Return $ret[0]
EndFunc                                                              ;==>glewInit


Func glActiveTexture($textur)
    Local $ret = DllCallAddress("int", get_glew_address("__glewActiveTexture"), 'int', $textur)
    Return $ret[0]
EndFunc                                                              ;==>glActiveTexture


Func glVertexPointer($size, $type, $stride, $ptr)
    Local $ret = DllCall('opengl32.dll', 'int', 'glVertexPointer', 'int', $size, 'int', $type, 'int', $stride, 'int*', $ptr)
    Return $ret[0]
EndFunc                                                              ;==>glVertexPointer


Func glDrawArrays($mode, $first, $count)                             ;
    Local $ret = DllCall('opengl32.dll', 'int', 'glDrawArrays', 'int', $mode, 'int', $first, 'int', $count)
    Return $ret[0]
EndFunc                                                              ;==>glDrawArrays


Func _glewIsSupported($str)
    ; ---
    Local $ret = DllCall($glew_hDLL, "int", "_glewIsSupported@4", "str", $str)
    Return SetError($ret[0] = 0, 0, $ret[0] = 1)
EndFunc                                                              ;==>_glewIsSupported


Func get_glew_address($func)                                         ; by Andy@autoit.de
    $ret = DllCall("kernel32.dll", "ptr", "GetProcAddress", "ptr", _WinAPI_GetModuleHandle("glew32.dll"), "str", $func)
;~ _arraydisplay($ret)
    $struct = DllStructCreate("dword", $ret[0])                      ;einsprungadresse, hier steht der pointer zur funktion
    Return DllStructGetData($struct, 1, 1)
EndFunc                                                              ;==>get_glew_address


Func clCreateFromGLBuffer($context, $flag, $bufferObj, $errcode_ret) ;
    $aCall = DllCall($OpenCl_dll, "int_ptr", "clCreateFromGLBuffer", "int_ptr", $context, "uint64", $flag, "int_ptr", $bufferObj, "int", DllStructGetPtr($errcode_ret))
    ; _ArrayDisplay($aCall)
    If $CL_DEBUGFLAG Then
        If @error Then
            MsgBox(0, 'Error in Function ''clCreateFromGLBuffer''   DllCall() failed', ' Returncode ' & @error)
            Return SetError(1, 0, -1)
        EndIf
        If OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)) <> 'CL_SUCCESS' Then
            MsgBox(0, 'Error in Function clCreateFromGLBuffer', '  Returncode: ' & OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)))
        Else
            ConsoleWrite('clCreateFromGLBuffer  CL_SUCCESS' & @CRLF)
        EndIf
    EndIf
    Return $aCall[0]

EndFunc                                                              ;==>clCreateFromGLBuffer


Func clEnqueueAcquireGLObjects($queue, $num_obj, $mem_Obj, $num_events_in_wait_list, $event_wait_list, $eventlist);
    $aCall = DllCall($OpenCl_dll, "int_ptr", "clEnqueueAcquireGLObjects", "int_ptr", $queue, "uint", $num_obj, "int_ptr*", $mem_Obj, "uint", $num_events_in_wait_list, "int_ptr", DllStructGetPtr($event_wait_list), "long", DllStructGetPtr($eventlist))
    ;  _ArrayDisplay($aCall)
    If $CL_DEBUGFLAG Then
        If @error Then
            MsgBox(0, 'Error in Function ''clEnqueueAcquireGLObjects''   DllCall() failed', ' Returncode ' & @error)
            Return SetError(1, 0, -1)
        EndIf
        If OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)) <> 'CL_SUCCESS' Then
            MsgBox(0, 'Error in Function clEnqueueAcquireGLObjects', '  Returncode: ' & OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)))
        Else
            ConsoleWrite('clEnqueueAcquireGLObjects  CL_SUCCESS' & @CRLF)
        EndIf
    EndIf
    Return $aCall[0]

EndFunc                                                              ;==>clEnqueueAcquireGLObjects



Func clEnqueueReleaseGLObjects($queue, $num_obj, $mem_Obj, $num_events_in_wait_list, $event_wait_list, $eventlist);
    $aCall = DllCall($OpenCl_dll, "int_ptr", "clEnqueueReleaseGLObjects", "int_ptr", $queue, "uint", $num_obj, "int_ptr*", $mem_Obj, "uint", $num_events_in_wait_list, "int_ptr", DllStructGetPtr($event_wait_list), "long", DllStructGetPtr($eventlist))
    ;  _ArrayDisplay($aCall)
    If $CL_DEBUGFLAG Then
        If @error Then
            MsgBox(0, 'Error in Function ''clEnqueueReleaseGLObjects''   DllCall() failed', ' Returncode ' & @error)
            Return SetError(1, 0, -1)
        EndIf
        If OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)) <> 'CL_SUCCESS' Then
            MsgBox(0, 'Error in Function clEnqueueReleaseGLObjects', '  Returncode: ' & OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)))
        Else
            ConsoleWrite('clEnqueueReleaseGLObjects  CL_SUCCESS' & @CRLF)
        EndIf
    EndIf
    Return $aCall[0]

EndFunc                                                              ;==>clEnqueueReleaseGLObjects



Func clGetDeviceIDs($platform, $device_type, $num_entries, $devices, $num_devices)
    $aCall = DllCall($OpenCl_dll, "long", "clGetDeviceIDs", "dword", $platform, "int64", $device_type, "dword", $num_entries, "int_ptr", $devices, "int_ptr", $num_devices)
    ;  _ArrayDisplay($aCall)
    If $CL_DEBUGFLAG Then
        If @error Then
            MsgBox(0, 'Error in Function ''clGetDeviceIDs''   DllCall() failed', ' Returncode ' & @error)
            Return SetError(1, 0, -1)
        EndIf
        If OpenCL_DecodeError($aCall[0]) <> 'CL_SUCCESS' Then
            MsgBox(0, 'Error in Function clGetDeviceIDs', '  Returncode: ' & OpenCL_DecodeError($aCall[0]))
        Else
            ConsoleWrite('clGetDeviceIDs  CL_SUCCESS' & @CRLF)
        EndIf
    EndIf
    Return $aCall[0]
EndFunc                                                              ;==>clGetDeviceIDs



Func clCreateFromGLTexture2D($context, $flags, $texture_target, $miplevel, $texture, $errcode_ret);
    $aCall = DllCall($OpenCl_dll, "int_ptr", "clCreateFromGLTexture2D", "int_ptr", $context, "int64", $flags, "int_ptr", $texture_target, "int", $miplevel, "uint", $texture, "int", DllStructGetPtr($errcode_ret))
    ;_arraydisplay($acall)
    If $CL_DEBUGFLAG Then
        If @error Then
            MsgBox(0, 'Error in Function ''clCreateFromGLTexture2D''   DllCall() failed', ' Returncode ' & @error)
            Return SetError(1, 0, -1)
        EndIf
        If OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)) <> 'CL_SUCCESS' Then
            MsgBox(0, 'Error in Function clCreateFromGLTexture2D', '  Returncode: ' & OpenCL_DecodeError(DllStructGetData($errcode_ret, 1)))
        Else
            ConsoleWrite('clCreateFromGLTexture2D  CL_SUCCESS' & @CRLF)
        EndIf
    EndIf
    Return $aCall[0]
EndFunc                                                              ;==>clCreateFromGLTexture2D


